/**************************************************************
  (C) 1997 by Achim Kaiser

  You may distribute under the terms of the GNU General Public
  License as specified in the COPYING file.
**************************************************************/

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "filemanager.h"
#include "shell.h"
#include "global.h"
#include "iwc.h"
#include "timer.h"


int NumberOfCmd(char* start)
{
  int i,j;
  j=0;
  for (i=0;i<strlen(start);i++)
    if (start[i]=='&')
      j++;
  j++;
  return j;
}

char* ExtractCmd(char* start,int shnr)
{
  char* back;
  int i,j,z;
  back=malloc(strlen(start)+1);
  i=0;j=0;z=0;
  do {
    back[j]=start[i];
    i++;
    j++;
    if (start[i-1]=='&') {
      back[j-1]=0;
      j=0;
      z++;
    }
  } while (shnr>=z && start[i-1]!=0);
  return(back);
}
    

int usershellsystem(char* command)
{
  char *text;
  int ret;
  StopAlarm();  
  text=malloc(strlen("$SHELL -c X X ")+strlen(command)+1);
  strcpy(text,"$SHELL -c \'");
  strcat(text,command);
  strcat(text,"\'");
  ret=system(text);
  free(text);
  ReactivateAlarm();
  return(ret);
}


void ExecuteShellWithFollowLink(char *filename,char *start,char *files,int shnr)
{
  char *text;
  if (strcmp(filename,"~/.dfmdesk/.linktohomedir/")==0)
    ExecuteShellcommand("~/",start,NULL,shnr);
  else if (strcmp(filename,"~/.dfmdesk/.linktorootdir/")==0)
    ExecuteShellcommand("/",start,NULL,shnr);
  else {
    text=malloc(strlen(filename)+1);
    strcpy(text,filename);
    GetLinkName(&text);
    ExecuteShellcommand(text,start,files,shnr);
    free(text);
  }
}


void ExecuteShellcommand(char *filename,char *start,char *files,int shnr)
{
  char *shelltext;
  char *start2;
  int i,j,exe,ext;
  start2=ExtractCmd(start,shnr);
  if (IsSubDesktop()==True && GetKindOfWindow()==NORMAL) {
    if (strcmp(start2,"dfm !0!")==0 ||
	strcmp(start2,"dfm !0! -structure")==0 ||
	strcmp(start2,"dfm !0! -detail")==0) 
      SetWindowSaveStatus(filename,True);
  }
  if (strlen(start2)>=3) {
    if (files!=NULL) 
      shelltext=malloc((strlen(filename)+strlen(start2)
			+strlen(files)+5)*sizeof(char));
    else
      shelltext=malloc((strlen(filename)+strlen(start2)
			+5)*sizeof(char));      
    j=0;exe=0;ext=0;
    for (i=0;i<strlen(start2)-2;i++) {
      if (start2[i]=='!' &&
	  start2[i+1]=='0' &&
	  start2[i+2]=='!' &&
	  exe==0) {
	strcpy(shelltext+j,filename);
	exe++;
	i=i+2;
	j=j+strlen(filename);
      } else {
	if (start2[i]=='!' &&
	    start2[i+1]=='1' &&
	    start2[i+2]=='!' && 
	    ext==0) {
	  if (files!=NULL){
	    strcpy(shelltext+j,files);
	    j=j+strlen(files);
	  }
	  ext++;
	  i=i+2;
	} else {
	  shelltext[j]=start2[i];
	  j++;
	}
      }
    }
    while (start2[i]!=0) {
      shelltext[j]=start2[i];
      j++;i++;
    }
    if (ext==0) {
      if (files!=NULL){      
	shelltext[j]=' ';j++;
	strcpy(shelltext+j,files);
	j=j+strlen(files);
      }
    }
    shelltext[j]=' ';j++;
    shelltext[j]='&';j++;
    shelltext[j]= 0 ;j++;
    if (exe>0) {
      usershellsystem(shelltext);
    }
  free(shelltext);
  }
  free(start2);
}
